



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>Oracle：Authid Current_User使用</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">Oracle：Authid Current_User使用</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-03-28 17:28:32 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>由于用户拥有的role权限在存储过程是不可用的。遇到这种情况，我们一般需要显示授权，如grant create table to user;但这种方法太麻烦，有时候可能需要进行非常多的授权才能执行存储过程，实际上，oracle给我们提供了在存储过程中使用role权限的方法：修改存储过程，加入Authid Current_User时存储过程可以使用role权限。</p>
<p>下面以例子说明：</p>
<div>
<pre class="prettyprint linenums">----执行存储过程p_create_emp2报下面的错误：<br />
SQL&gt; exec p_create_emp2;

begin p_create_emp2; end;

ORA-01031: 权限不足<br />
ORA-06512: 在 "ECHO.P_CREATE_EMP2", line 12<br />
ORA-06512: 在 line 2

----查看p_create_emp2，该存储过程是要创建emp2表<br />
create or replace procedure P_create_emp2 as<br />
  cursor t_cursor is<br />
  select * from user_tables where table_name = 'EMP2';<br />
  t_cur t_cursor%rowtype;<br />
  num int:=0;<br />
begin<br />
  for t_cur in t_cursor loop<br />
   num:=num+1;<br />
  end loop;<br />
  if num=1 then<br />
    execute immediate 'drop table emp2 purge';<br />
    execute immediate 'create table emp2 as select * from emp';<br />
  else<br />
    execute immediate 'create table emp2 as select * from emp';<br />
  end if;<br />
end P_create_emp2;

----查看echo用户的角色或权限<br />
SQL&gt; select * from dba_role_privs where grantee='ECHO';

GRANTEE                        GRANTED_ROLE                   ADMIN_OPTION DEFAULT_ROLE<br />
------------------------------ ------------------------------ ------------ ------------<br />
ECHO                           DBA                            NO           YES<br />
----有dba的角色，说明建表的权限

----修改存储过程p_create_emp2：<br />
create or replace procedure P_create_emp2 authid current_user as<br />
  cursor t_cursor is<br />
  select * from user_tables where table_name = 'EMP2';<br />
  t_cur t_cursor%rowtype;<br />
  num int:=0;<br />
begin<br />
  for t_cur in t_cursor loop<br />
   num:=num+1;<br />
  end loop;<br />
  if num=1 then<br />
    execute immediate 'drop table emp2 purge';<br />
    execute immediate 'create table emp2 as select * from emp';<br />
  else<br />
    execute immediate 'create table emp2 as select * from emp';<br />
  end if;<br />
end P_create_emp2;

----再次执行：<br />
SQL&gt; exec p_create_emp2;

PL/SQL procedure successfully completed

SQL&gt; desc emp2;<br />
Name     Type         Nullable Default Comments<br />
-------- ------------ -------- ------- --------<br />
EMPNO    NUMBER(4)    Y<br />
ENAME    VARCHAR2(10) Y<br />
JOB      VARCHAR2(9)  Y<br />
MGR      NUMBER(4)    Y<br />
HIREDATE DATE         Y<br />
SAL      NUMBER(7,2)  Y<br />
COMM     NUMBER(7,2)  Y<br />
DEPTNO   NUMBER(2)    Y                

----在存储过程加了Authid Current_User选项，表创建成功。</pre>
</div>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/oqvp1yzq.html">CentOS出错You don&amp;&num;39&semi;t have permission to access on this server</a>
		</li>
						<li><a href="https://www.batexi.com/a/qyd60v2q.html">BT之下拉菜单</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn0v4rq.html">Asp&period;Net--上传大文件&lpar;页面超时&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pdjw3z9.html">perl 继承概述</a>
		</li>
						<li><a href="https://www.batexi.com/a/qdpjm67q.html">Linux中kettle连接hadoop并传数据（5）</a>
		</li>
						<li><a href="https://www.batexi.com/a/8melxxoq.html">&lbrack;Angular Tutorial&rsqb; 1-Static Template</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjw3wk8.html">删除oracle数据库&lbrack;转&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/8merpw2q.html">MongoDB正则表达式</a>
		</li>
						<li><a href="https://www.batexi.com/a/q4z17zj9.html">Docker标准化开发测试和生产环境</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mxoe48.html">SSM-Spring-10：Spring中cglib动态代理</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy1zorjq.html">android studio 开发免安装的app之目录结构</a>
		</li>
						<li><a href="https://www.batexi.com/a/qljy4xx9.html">JS高德地图计算两地之间的实际距离</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rk1458.html">关于学习python的想法</a>
		</li>
						<li><a href="https://www.batexi.com/a/8e45lrj9.html">jira迁移数据</a>
		</li>
						<li><a href="https://www.batexi.com/a/q7o2mo18.html">《Practical Vim》第十章&colon;复制和粘贴</a>
		</li>
						<li><a href="https://www.batexi.com/a/960kex39.html">Webpack中的css-loader 和style-loader</a>
		</li>
						<li><a href="https://www.batexi.com/a/qll0pzeq.html">Page13：跟踪问题、最优控制&lbrack;Linear System Theory&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/q25zd1xq.html">GTK 菜单的创建详解</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2yjlx9.html">最简单的TTcpServer与TTcpClient通信实例-Delphi</a>
		</li>
						<li><a href="https://www.batexi.com/a/9gjopyz9.html">SET NOCOUNT ON</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/0qw73kl8.html">Java数据库连接&mdash;&mdash;JDBC调用存储过程&comma;事务管理和高级应用</a>
			</li>
						<li><a href="https://www.batexi.com/a/1q27pyv8.html">RFS一些基本概念</a>
			</li>
						<li><a href="https://www.batexi.com/a/390wwojq.html">JAVA NIO系列（三） Buffer 解读</a>
			</li>
						<li><a href="https://www.batexi.com/a/qde0e2x9.html">MFC主窗口架构模型</a>
			</li>
						<li><a href="https://www.batexi.com/a/90v7mom8.html">ofbiz进击 第三节。 各个关键文件的说明与作用</a>
			</li>
						<li><a href="https://www.batexi.com/a/8e1e42z9.html">JSP数据交互习题错误总结</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnwl6v8.html">oracle冷备份后恢复</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxnwl7d8.html">夺命雷公狗---Thinkphp----6之管理员的增删改查之-未验证</a>
			</li>
						<li><a href="https://www.batexi.com/a/q4yg4e5q.html">clock</a>
			</li>
						<li><a href="https://www.batexi.com/a/9rdzykr8.html">SQL&mdash;&mdash; 事务</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
